Debian Bug report logs - #367831
FTBFS with GCC 4.2: fusebirth segfaults

version graph

Package: freebirth; Maintainer for freebirth is Paul Brossier <piem@debian.org>; Source for freebirth is src:freebirth.

Reported by: Martin Michlmayr <tbm@cyrius.com>

Date: Thu, 18 May 2006 12:48:05 UTC

Severity: serious

Tags: lenny, sid

Found in version freebirth/0.3.2-7

Done: Steve McIntyre <steve@einval.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Paul Brossier <piem@debian.org>:
Bug#367831; Package freebirth. Full text and rfc822 format available.

Acknowledgement sent to Martin Michlmayr <tbm@cyrius.com>:
New Bug report received and forwarded. Copy sent to Paul Brossier <piem@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Martin Michlmayr <tbm@cyrius.com>
To: submit@bugs.debian.org
Subject: FTBFS with GCC 4.2: fusebirth segfaults
Date: Thu, 18 May 2006 14:38:09 +0200
Package: freebirth
Version: 0.3.2-7

fusebirth segfaults (at least on powerpc) when I compile it with a
snapshot of GCC 4.2.  I'm not entirely sure whether this is a compiler
bug or one in your package, but from other cases like these it is
likely that your package is doing something wrong and that newer
optimizations exhibit the problem.

Maybe you or your upstream can investigate.  If everything fails, I
can talk to someone who knows GCC well.

I've done some preliminary investigation which shows where the error
is.  The segfault goes away if you drop the optimization from
oscillator.c.  A traceback shows:

Program received signal SIGSEGV, Segmentation fault.
topo_sort (node=0xffff8008, order=0xfffa2968) at fuse_loops.c:43
43          for (children = node->get_children(node);
(gdb) where
#0  topo_sort (node=0xffff8008, order=0xfffa2968) at fuse_loops.c:43
#1  0x1000dbe8 in topo_sort (node=0x100d80d8, order=0xfffa2968) at fuse_loops.c:46
#2  0x1000dbe8 in topo_sort (node=0x100d9130, order=0xfffa2968) at fuse_loops.c:46
#3  0x1000dbe8 in topo_sort (node=0x100da9f0, order=0xfffa2968) at fuse_loops.c:46
#4  0x1000dbe8 in topo_sort (node=0x100dba88, order=0xfffa2968) at fuse_loops.c:46
#5  0x1000dbe8 in topo_sort (node=0x100ffbb8, order=0xfffa2968) at fuse_loops.c:46
#6  0x1000dc70 in fuse_loops (left=0x0, right=0x10100478, file=0x101013e8) at fuse_loops.c:119
#7  0x10006b44 in main (argc=<value optimized out>, argv=<value optimized out>) at freebirth.c:134
(gdb)


> Automatic build of freebirth_0.3.2-7 on test.track.rz.uni-augsburg.de by sbuild/powerpc 0.44
...
> gcc -g -Wall -I/usr/include/gtk-2.0 -I/usr/lib/gtk-2.0/include -I/usr/include/atk-1.0 -I/usr/include/cairo -I/usr/include/pango-1.0 -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include   -O2   -c -o oscillator.o oscillator.c
...
> gcc -lgtk-x11-2.0 -lgdk-x11-2.0 -latk-1.0 -lgdk_pixbuf-2.0 -lm -lpangocairo-1.0 -lfontconfig -lXext -lXrender -lXinerama -lXi -lXrandr -lXcursor -lXfixes -lpango-1.0 -lcairo -lX11 -lgobject-2.0 -lgmodule-2.0 -ldl -lglib-2.0    fusebirth.o oscillator.o sequencer.o envelope.o filter.o gtkdial.o mixer.o raw_wave.o event.o sample_producer.o blender.o delay.o reverb.o all_pass.o delay_panel.o reverb_panel.o multi_tap_delay.o sample_freq_strip.o fuse_loops.o -lm -L/usr/lib -lgtk-x11-2.0  -o fusebirth
> ./fusebirth > fused_loop.c 2>/dev/null
> /bin/sh: line 1: 24295 Segmentation fault      ./fusebirth >fused_loop.c 2>/dev/null
> make[1]: *** [fused_loop.c] Error 139

-- 
Martin Michlmayr
http://www.cyrius.com/



Information forwarded to debian-bugs-dist@lists.debian.org, Paul Brossier <piem@debian.org>:
Bug#367831; Package freebirth. Full text and rfc822 format available.

Acknowledgement sent to Martin Michlmayr <tbm@cyrius.com>:
Extra info received and forwarded to list. Copy sent to Paul Brossier <piem@debian.org>. Full text and rfc822 format available.

Message #10 received at 367831@bugs.debian.org (full text, mbox):

From: Martin Michlmayr <tbm@cyrius.com>
To: 367831@bugs.debian.org
Subject: Re: Bug#367831: FTBFS with GCC 4.2: fusebirth segfaults
Date: Thu, 18 May 2006 15:00:55 +0200
* Martin Michlmayr <tbm@cyrius.com> [2006-05-18 14:38]:
> fusebirth segfaults (at least on powerpc) when I compile it with a

I don't see this on i386.  If you or your upstream cannot figure it
out from the source, I can probably make access to a powerpc box
available.
-- 
Martin Michlmayr
http://www.cyrius.com/



Information forwarded to debian-bugs-dist@lists.debian.org, Paul Brossier <piem@debian.org>:
Bug#367831; Package freebirth. Full text and rfc822 format available.

Acknowledgement sent to "brian m. carlson" <sandals@crustytoothpaste.ath.cx>:
Extra info received and forwarded to list. Copy sent to Paul Brossier <piem@debian.org>. Full text and rfc822 format available.

Message #15 received at 367831@bugs.debian.org (full text, mbox):

From: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>
To: 367831@bugs.debian.org
Subject: 367831: builds fine on amd64, too
Date: Mon, 7 May 2007 17:18:50 +0000
Just as a data point, freebirth builds fine on amd64 as well.  I might
eventually get around to booting an old powerpc machine and trying it,
but don't hold your breath.

-- 
brian m. carlson / brian with sandals: Houston, Texas, US
+1 713 440 7475 | http://crustytoothpaste.ath.cx/~bmc | My opinion only
Screw you, AACS LA: 09 F9 11 02 9D 74 E3 5B D8 41 56 C5 63 56 88 C0
OpenPGP: RSA v3 2048b 560553E7: FE82 7C9F EB21 5436 2F96 25BA 927B 0A51



Severity set to `important' from `normal' Request was from Matthias Klose <doko@cs.tu-berlin.de> to control@bugs.debian.org. (Tue, 29 May 2007 09:12:40 GMT) Full text and rfc822 format available.

Severity set to `serious' from `important' Request was from Matthias Klose <doko@cs.tu-berlin.de> to control@bugs.debian.org. (Sat, 01 Sep 2007 11:06:19 GMT) Full text and rfc822 format available.

Tags added: lenny, sid Request was from Kurt Roeckx <kurt@roeckx.be> to control@bugs.debian.org. (Sun, 02 Sep 2007 15:27:20 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Paul Brossier <piem@debian.org>:
Bug#367831; Package freebirth. Full text and rfc822 format available.

Acknowledgement sent to Paul Brossier <piem@piem.org>:
Extra info received and forwarded to list. Copy sent to Paul Brossier <piem@debian.org>. Full text and rfc822 format available.

Message #26 received at 367831@bugs.debian.org (full text, mbox):

From: Paul Brossier <piem@piem.org>
To: Martin Michlmayr <tbm@cyrius.com>, "brian m. carlson" <sandals@crustytoothpaste.ath.cx>, 367831@bugs.debian.org
Subject: Re: Bug#367831: 367831: builds fine on amd64, too
Date: Fri, 28 Sep 2007 14:51:50 +0100
hi,

unfortunately, i don't have access to powerpc at the moment, so Martin,
any help would be greatly appreciated.

cheers, Paul

On Mon, May 07, 2007 at 05:18:50PM +0000, brian m. carlson wrote:
> Just as a data point, freebirth builds fine on amd64 as well.  I might
> eventually get around to booting an old powerpc machine and trying it,
> but don't hold your breath.
> 
> -- 
> brian m. carlson / brian with sandals: Houston, Texas, US
> +1 713 440 7475 | http://crustytoothpaste.ath.cx/~bmc | My opinion only
> Screw you, AACS LA: 09 F9 11 02 9D 74 E3 5B D8 41 56 C5 63 56 88 C0
> OpenPGP: RSA v3 2048b 560553E7: FE82 7C9F EB21 5436 2F96 25BA 927B 0A51
> 
> 




Information forwarded to debian-bugs-dist@lists.debian.org, Paul Brossier <piem@debian.org>:
Bug#367831; Package freebirth. Full text and rfc822 format available.

Acknowledgement sent to Martin Michlmayr <tbm@cyrius.com>:
Extra info received and forwarded to list. Copy sent to Paul Brossier <piem@debian.org>. Full text and rfc822 format available.

Message #31 received at 367831@bugs.debian.org (full text, mbox):

From: Martin Michlmayr <tbm@cyrius.com>
To: Paul Brossier <piem@piem.org>
Cc: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>, 367831@bugs.debian.org
Subject: Re: Bug#367831: 367831: builds fine on amd64, too
Date: Wed, 3 Oct 2007 18:51:55 +0200
* Paul Brossier <piem@piem.org> [2007-09-28 14:51]:
> unfortunately, i don't have access to powerpc at the moment, so Martin,
> any help would be greatly appreciated.

I just tried to compile the current version of freebirth with the
current gcc (4.2) version in unstable, and it still segfaults.
-- 
Martin Michlmayr
http://www.cyrius.com/




Information forwarded to debian-bugs-dist@lists.debian.org, Paul Brossier <piem@debian.org>:
Bug#367831; Package freebirth. Full text and rfc822 format available.

Acknowledgement sent to Paul Brossier <piem@piem.org>:
Extra info received and forwarded to list. Copy sent to Paul Brossier <piem@debian.org>. Full text and rfc822 format available.

Message #36 received at 367831@bugs.debian.org (full text, mbox):

From: Paul Brossier <piem@piem.org>
To: Martin Michlmayr <tbm@cyrius.com>, 367831@bugs.debian.org
Cc: "brian m. carlson" <sandals@crustytoothpaste.ath.cx>, control@bugs.debian.org
Subject: Re: Bug#367831: 367831: builds fine on amd64, too
Date: Mon, 4 Feb 2008 23:13:18 +0100
[Message part 1 (text/plain, inline)]
tags 367831 +pending
thanks
--

hi,

well, i got to reproduce this bug on my 'new' powerpc machine.

but, mmh, i still haven't found a way around it though.

the problem seems to lie somewhere in topo_sort, a recursive function,
when it reaches the end of graph branches, hitting NULL pointer there.

fusebirth is only used to generate fused_loop.c, which is then used to
build the final freebirth. so shipping a generated fused_loop.c instead
of trying to generate it every time would be a solution.

i still wonder why this code (although quite ugly) behaves correctly on
the other arches, and runs on powerpc with -O0...

cheers, Paul

On Wed, Oct 03, 2007 at 06:51:55PM +0200, Martin Michlmayr wrote:
> * Paul Brossier <piem@piem.org> [2007-09-28 14:51]:
> > unfortunately, i don't have access to powerpc at the moment, so Martin,
> > any help would be greatly appreciated.
> 
> I just tried to compile the current version of freebirth with the
> current gcc (4.2) version in unstable, and it still segfaults.
> -- 
> Martin Michlmayr
> http://www.cyrius.com/
> 
> 
> 
[signature.asc (application/pgp-signature, inline)]

Tags added: pending Request was from Paul Brossier <piem@piem.org> to control@bugs.debian.org. (Mon, 04 Feb 2008 22:18:03 GMT) Full text and rfc822 format available.

Removed tag(s) pending. Request was from Adam D. Barratt <adam@adam-barratt.org.uk> to control@bugs.debian.org. (Sun, 29 Nov 2009 20:18:11 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Paul Brossier <piem@debian.org>:
Bug#367831; Package freebirth. (Sat, 15 Oct 2011 00:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to peter green <peter.green@postgrad.manchester.ac.uk>:
Extra info received and forwarded to list. Copy sent to Paul Brossier <piem@debian.org>. (Sat, 15 Oct 2011 00:57:03 GMT) Full text and rfc822 format available.

Message #45 received at 367831@bugs.debian.org (full text, mbox):

From: peter green <peter.green@postgrad.manchester.ac.uk>
To: 367831@bugs.debian.org
Subject: Re: Bug#367831: 367831: builds fine on amd64, too
Date: Sat, 15 Oct 2011 01:55:04 +0100
>fusebirth is only used to generate fused_loop.c, which is then used to
>build the final freebirth. so shipping a generated fused_loop.c instead
>of trying to generate it every time would be a solution.
IMO if this is still an issue building the generator with -O0 would be a 
more appropriate soloution for debian than shipping the generated code.





Reply sent to Steve McIntyre <steve@einval.com>:
You have taken responsibility. (Sun, 04 Mar 2012 12:56:03 GMT) Full text and rfc822 format available.

Notification sent to Martin Michlmayr <tbm@cyrius.com>:
Bug acknowledged by developer. (Sun, 04 Mar 2012 12:56:23 GMT) Full text and rfc822 format available.

Message #50 received at 367831-done@bugs.debian.org (full text, mbox):

From: Steve McIntyre <steve@einval.com>
To: 367831-done@bugs.debian.org
Subject: Re: Bug#367831: 367831: builds fine on amd64, too
Date: Sun, 4 Mar 2012 12:53:40 +0000
On Sat, Oct 15, 2011 at 01:55:04AM +0100, peter green wrote:
>>fusebirth is only used to generate fused_loop.c, which is then used to
>>build the final freebirth. so shipping a generated fused_loop.c instead
>>of trying to generate it every time would be a solution.
>IMO if this is still an issue building the generator with -O0 would
>be a more appropriate soloution for debian than shipping the
>generated code.

Just tested on a ppc running sid today using gcc 4.6.3 and this builds
just fine. Looks to have been a temporary toolchain problem on ppc,
maybe. Closing.

-- 
Steve McIntyre, Cambridge, UK.                                steve@einval.com
Into the distance, a ribbon of black
Stretched to the point of no turning back





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 02 Apr 2012 07:36:36 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 01:11:54 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.